﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.XamDataGrid.DataSource = new CData[] { new CData(), new CData() };
        }
        private void BeginDrag(object sender, MouseButtonEventArgs e)
        {
            // can't start drag & drop here because otherwise selecting a record will trigger 
        }
        private void PreviewMouseMove1(object sender, MouseEventArgs e)
        {
            if (e.LeftButton == MouseButtonState.Pressed)
            {
                // this is never called:
                System.Windows.DragDrop.DoDragDrop((DependencyObject)sender, new DataObject(), DragDropEffects.Copy);
            }
        }

    }

    public class CProperty
    {
        internal CProperty(object aValue)
        {
            this.ValueM = aValue;
        }

        private object ValueM;
        public object Value { get { return this.ValueM; } set { this.ValueM = value; } }
    }

    public class CData
    {
        private CProperty Prop1M;
        public CProperty Prop1
        {
            get
            {
                if (null == this.Prop1M)
                {
                    this.Prop1M = new CProperty("P1");
                }
                return this.Prop1M;
            }
        }

        private CProperty Prop2M;
        public CProperty Prop2
        {
            get
            {
                if (null == this.Prop2M)
                {
                    this.Prop2M = new CProperty("P2");
                }
                return this.Prop2M;
            }
        }
    }
}
